/*
 * @(#)$Id: $
 *
 * Copyright 2002 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package org.kohsuke.rmeter;

import org.xml.sax.Locator;

import com.sun.msv.grammar.ElementExp;
import com.sun.msv.grammar.NameClassAndExpression;
import com.sun.msv.reader.GrammarReader;

/**
 * 
 * @author
 * 	Kohsuke Kawaguchi (kohsuke.kawaguchi@sun.com)
 */
public class CollisionHandlerImpl implements CollisionHandler {
    public CollisionHandlerImpl( GrammarReader _reader ) {
        this.reader = _reader;
    }
    
    private final GrammarReader reader;
    private boolean hadCollision = false;
    
    public void onCollision( ElementExp parent,
        NameClassAndExpression exp1, NameClassAndExpression exp2) {
        
        hadCollision = true;
        
        
        System.out.print("  ");
        if( exp1 instanceof ElementExp )
            System.out.print("two element names collide at");
        else
            System.out.print("two attribute names collide at");
        printLocator(reader.getDeclaredLocationOf(exp1));
        System.out.print(" and");
        printLocator(reader.getDeclaredLocationOf(exp2));
        if(parent==null)
            System.out.print(". Both are root elements");
        else {
            System.out.print(" inside an element of");
            printLocator(reader.getDeclaredLocationOf(parent));
        }
        
        System.out.println();
    }
    
    public boolean hadCollision() { return hadCollision; }
    
    private void printLocator( Locator loc ) {
        if(loc==null)
            System.out.print(" unknown location");
        else
            System.out.print(" line "+loc.getLineNumber());
    }
}
