/*
 * @(#)$Id: $
 *
 * Copyright 2002 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */
package org.kohsuke.rmeter;

import com.sun.msv.driver.textui.DebugController;
import com.sun.msv.grammar.trex.TREXGrammar;
import com.sun.msv.reader.trex.ng.RELAXNGReader;

/**
 * 
 * @author
 * 	Kohsuke Kawaguchi (kohsuke.kawaguchi@sun.com)
 */
public class Main {

    public static void main(String[] args) {
        if(args.length==0) {
            System.out.println("Usage: java -jar relaxMeter.jar <schema file>");
            return;
        }
        
        boolean collision = false;
        for( int i=0; i<args.length; i++ ) {
            System.out.println("testing "+args[i]);
            collision |= run(args[i]);
        }
        System.exit(collision?-1:0);
    }
    
    public static boolean run( String url ) {
        // parse a grammar
        RELAXNGReader reader = new RELAXNGReader(new DebugController(false));
        reader.parse(url);
        TREXGrammar grammar = reader.getResult();
        
        CollisionHandlerImpl handler = new CollisionHandlerImpl(reader);
        new SingleTypeTester(handler).test(null,grammar);
        
        if(!handler.hadCollision())
            System.out.println("no collision detected");
        
        return handler.hadCollision();
    }
}
